SystemOrganization addCategory: #'Magritte-VerifiedTextInput'!

MATextInputComponent subclass: #MAVerifiedTextInputComponent
	instanceVariableNames: 'verification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-VerifiedTextInput'!

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 9/22/2008 00:09'!
doValidate

	"no change"
	self isReadonly ifTrue: [ ^ self ].

	(self value = self valueOriginal and: [ verification isEmpty ]) ifTrue: [ ^ self ].
	
	self value = verification ifFalse: [ MAKindError description: self description signal: self description kindErrorMessage ].! !

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 9/16/2008 13:00'!
isPassword

	^ self description respondsTo: #isObfuscated:! !

!MAVerifiedTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 9/16/2008 13:03'!
renderEditorOn: html

	self isPassword 
		ifTrue: [ self renderPasswordOn: html ]
		ifFalse: [ self renderTextInputOn: html ]! !

!MAVerifiedTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2008 23:08'!
renderPasswordOn: html

		html passwordInput
		id: self labelId;
		on: #string of: self.

		html passwordInput
		id: self labelId, 'b';
		on: #verification of: self.
		
		html text: ' (enter twice) '.! !

!MAVerifiedTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 9/21/2008 23:08'!
renderTextInputOn: html
	html textInput
		id: self labelId;
		on: #string of: self.

		html textInput
		id: self labelId, 'b';
		on: #verification of: self.
		
		html text: ' (enter twice) '.! !

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 9/16/2008 13:01'!
string

	self isPassword ifFalse: [ ^ super string ].
	
	^ self description obfuscated: self value! !

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 9/16/2008 13:01'!
string: aString

	self isPassword ifFalse: [ ^ super string: aString ].
	
	(self description isObfuscated: aString)
		ifFalse: [ super string: aString ]! !

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 9/21/2008 23:06'!
valueOriginal
	^ self model readUsing: self description! !

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 9/21/2008 23:05'!
verification
	"Answer the value of verification"

	^ verification! !

!MAVerifiedTextInputComponent methodsFor: 'accessing' stamp: 'kph 9/21/2008 23:05'!
verification: anObject
	"Set the value of verification"

	verification := anObject! !
